Subject: bug#48294: Use 'with-current-buffer' byte-compiler warning seems wrong

From: Robert Weiner <[email-masked]>
Date: Sun, 9 May 2021 11:57:25 -0400

Hi Eli:

Thanks for the feedback.  Everything you wrote is very clear.  The issue,
however, is that I want to save point in the current buffer prior to
switching context to the 'with-current-buffer' buffer, just as my
(save-excursion (set-buffer ...)) code does.  If I move the save-excursion
into the with-current-buffer body, then it applies to the new buffer not
the original one and if in that same body we change buffers again to the
original and move point, then that movement will stay in place.  So the
question is, what is the appropriate code that the byte-compiler will
accept when you want to save your original place before switching buffers.
Do I have to just do a (let ((opoint (point))) ...) and then restore it?
The issue is that within the with-current-buffer body, there could be a
hard to trace sequence of calls any of which could switch back to the
original buffer and move point.  So how would you protect against that?

Thanks,

Bob

On Sun, May 9, 2021 at 4:05 AM Eli Zaretskii <[email-masked]> wrote:

> tags 48294 notabug
> thanks
>
> > From: Robert Weiner <[email-masked]>
> > Date: Sat, 8 May 2021 16:14:09 -0400
> >
> > I get a lot of these byte-compile warnings in my Elisp code:
> >
> > hbut.el:683:26:Warning: Use ‘with-current-buffer’ rather than
> >     save-excursion+set-buffer
> >
> > but since with-current-buffer does not save the value of point, it is
> > not a valid substitute for save-excursion and should not be suggested.
> > Evaluate the two samples below and you will see that they are not
> > equivalent.  If I am correct, I'd like this suggestion disabled.
> Thanks.  -- rsw
> >
> > (save-excursion
> >   (set-buffer (current-buffer))
> >   (forward-char 20))
> >
> > (with-current-buffer (current-buffer)
> >   (forward-char 20))
>
> The ELisp manual says about this:
>
>      Because ‘save-excursion’ only saves point for the buffer that was
>   current at the start of the excursion, any changes made to point in
>   other buffers, during the excursion, will remain in effect afterward.
>   This frequently leads to unintended consequences, so the byte compiler
>   warns if you call ‘set-buffer’ during an excursion:
>
>        Warning: Use ‘with-current-buffer’ rather than
>                 save-excursion+set-buffer
>
>   To avoid such problems, you should call ‘save-excursion’ only after
>   setting the desired current buffer, as in the following example:
>
>        (defun append-string-to-buffer (string buffer)
>          "Append STRING to the end of BUFFER."
>          (with-current-buffer buffer
>            (save-excursion
>              (goto-char (point-max))
>              (insert string))))
>
> I believe this example shows how to solve your problem.
>